import{S as tl,i as nl,s as al,e as n,k as h,w as v,t as s,M as rl,c as a,d as t,m as p,a as r,x as y,h as i,b as l,G as e,g as u,y as w,q as k,o as T,B as M,v as sl,L as qs}from"../../chunks/vendor-hf-doc-builder.js";import{T as Es}from"../../chunks/Tip-hf-doc-builder.js";import{D as J}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Rt}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as G}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as zs}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function il(z){let m,$,_,g,b;return g=new Rt({props:{code:`from transformers import NllbMoeModel, NllbMoeConfig

# Initializing a NllbMoe facebook/nllb-moe-54b style configuration
configuration = NllbMoeConfig()

# Initializing a model from the facebook/nllb-moe-54b style configuration
model = NllbMoeModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> NllbMoeModel, NllbMoeConfig

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a NllbMoe facebook/nllb-moe-54b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = NllbMoeConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model from the facebook/nllb-moe-54b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = NllbMoeModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){m=n("p"),$=s("Example:"),_=h(),v(g.$$.fragment)},l(c){m=a(c,"P",{});var f=r(m);$=i(f,"Example:"),f.forEach(t),_=p(c),y(g.$$.fragment,c)},m(c,f){u(c,m,f),e(m,$),u(c,_,f),w(g,c,f),b=!0},p:qs,i(c){b||(k(g.$$.fragment,c),b=!0)},o(c){T(g.$$.fragment,c),b=!1},d(c){c&&t(m),c&&t(_),M(g,c)}}}function ll(z){let m,$,_,g,b;return{c(){m=n("p"),$=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=n("code"),g=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(c){m=a(c,"P",{});var f=r(m);$=i(f,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=a(f,"CODE",{});var q=r(_);g=i(q,"Module"),q.forEach(t),b=i(f,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),f.forEach(t)},m(c,f){u(c,m,f),e(m,$),e(m,_),e(_,g),e(m,b)},d(c){c&&t(m)}}}function dl(z){let m,$,_,g,b;return{c(){m=n("p"),$=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=n("code"),g=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(c){m=a(c,"P",{});var f=r(m);$=i(f,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=a(f,"CODE",{});var q=r(_);g=i(q,"Module"),q.forEach(t),b=i(f,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),f.forEach(t)},m(c,f){u(c,m,f),e(m,$),e(m,_),e(_,g),e(m,b)},d(c){c&&t(m)}}}function cl(z){let m,$,_,g,b;return g=new Rt({props:{code:`from transformers import AutoTokenizer, NllbMoeModel

tokenizer = AutoTokenizer.from_pretrained("hf-internal-testing/random-nllb-moe-2-experts")
model = SwitchTransformersModel.from_pretrained("hf-internal-testing/random-nllb-moe-2-experts")

input_ids = tokenizer(
    "Studies have been shown that owning a dog is good for you", return_tensors="pt"
).input_ids  # Batch size 1
decoder_input_ids = tokenizer("Studies show that", return_tensors="pt").input_ids  # Batch size 1

# preprocess: Prepend decoder_input_ids with start token which is pad token for NllbMoeModel
decoder_input_ids = model._shift_right(decoder_input_ids)

# forward pass
outputs = model(input_ids=input_ids, decoder_input_ids=decoder_input_ids)
last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, NllbMoeModel

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/random-nllb-moe-2-experts&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = SwitchTransformersModel.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/random-nllb-moe-2-experts&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;Studies have been shown that owning a dog is good for you&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>
<span class="hljs-meta">... </span>).input_ids  <span class="hljs-comment"># Batch size 1</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_input_ids = tokenizer(<span class="hljs-string">&quot;Studies show that&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids  <span class="hljs-comment"># Batch size 1</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># preprocess: Prepend decoder_input_ids with start token which is pad token for NllbMoeModel</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_input_ids = model._shift_right(decoder_input_ids)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(input_ids=input_ids, decoder_input_ids=decoder_input_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){m=n("p"),$=s("Example:"),_=h(),v(g.$$.fragment)},l(c){m=a(c,"P",{});var f=r(m);$=i(f,"Example:"),f.forEach(t),_=p(c),y(g.$$.fragment,c)},m(c,f){u(c,m,f),e(m,$),u(c,_,f),w(g,c,f),b=!0},p:qs,i(c){b||(k(g.$$.fragment,c),b=!0)},o(c){T(g.$$.fragment,c),b=!1},d(c){c&&t(m),c&&t(_),M(g,c)}}}function hl(z){let m,$,_,g,b;return{c(){m=n("p"),$=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=n("code"),g=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(c){m=a(c,"P",{});var f=r(m);$=i(f,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=a(f,"CODE",{});var q=r(_);g=i(q,"Module"),q.forEach(t),b=i(f,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),f.forEach(t)},m(c,f){u(c,m,f),e(m,$),e(m,_),e(_,g),e(m,b)},d(c){c&&t(m)}}}function pl(z){let m,$,_,g,b;return g=new Rt({props:{code:`from transformers import AutoTokenizer, NllbMoeForConditionalGeneration

model = NllbMoeForConditionalGeneration.from_pretrained("facebook/nllb-moe-54b")
tokenizer = AutoTokenizer.from_pretrained("facebook/nllb-moe-54b")

text_to_translate = "Life is like a box of chocolates"
model_inputs = tokenizer(text_to_translate, return_tensors="pt")

# translate to French
gen_tokens = model.generate(**model_inputs, forced_bos_token_id=tokenizer.get_lang_id("eng_Latn"))
print(tokenizer.batch_decode(gen_tokens, skip_special_tokens=True))`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, NllbMoeForConditionalGeneration

<span class="hljs-meta">&gt;&gt;&gt; </span>model = NllbMoeForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;facebook/nllb-moe-54b&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;facebook/nllb-moe-54b&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>text_to_translate = <span class="hljs-string">&quot;Life is like a box of chocolates&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model_inputs = tokenizer(text_to_translate, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># translate to French</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>gen_tokens = model.generate(**model_inputs, forced_bos_token_id=tokenizer.get_lang_id(<span class="hljs-string">&quot;eng_Latn&quot;</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(tokenizer.batch_decode(gen_tokens, skip_special_tokens=<span class="hljs-literal">True</span>))`}}),{c(){m=n("p"),$=s("Translation example:"),_=h(),v(g.$$.fragment)},l(c){m=a(c,"P",{});var f=r(m);$=i(f,"Translation example:"),f.forEach(t),_=p(c),y(g.$$.fragment,c)},m(c,f){u(c,m,f),e(m,$),u(c,_,f),w(g,c,f),b=!0},p:qs,i(c){b||(k(g.$$.fragment,c),b=!0)},o(c){T(g.$$.fragment,c),b=!1},d(c){c&&t(m),c&&t(_),M(g,c)}}}function ul(z){let m,$,_,g,b,c,f,q,Dn,Ht,U,de,Ho,Pe,Gn,Wo,Bn,Wt,ce,In,Se,Rn,Hn,Jt,bo,Wn,Ut,vo,Jo,Jn,Vt,yo,Un,Kt,B,Uo,Vn,Kn,Vo,Zn,Xn,Ko,Yn,Zt,I,Qn,Ae,ea,oa,je,ta,na,Xt,V,he,Zo,Oe,aa,Xo,ra,Yt,K,pe,Yo,De,sa,Qo,ia,Qt,R,la,et,da,ca,ot,ha,pa,en,H,ua,tt,ma,fa,Ge,ga,_a,on,Be,tn,Z,ue,nt,Ie,ba,at,va,nn,W,ya,rt,wa,ka,st,Ta,Ma,an,wo,$a,rn,Re,sn,X,me,it,He,Na,lt,xa,ln,fe,dt,ko,Ea,za,ct,To,qa,dn,Y,ge,ht,We,Ca,pt,La,cn,L,Je,Fa,Q,Pa,Mo,Sa,Aa,Ue,ja,Oa,Da,ee,Ga,$o,Ba,Ia,No,Ra,Ha,Wa,_e,hn,oe,be,ut,Ve,Ja,mt,Ua,pn,N,Ke,Va,ft,Ka,Za,Ze,Xa,gt,Ya,Qa,er,_t,or,tr,ve,Xe,nr,te,ar,bt,rr,sr,vt,ir,lr,dr,ye,Ye,cr,yt,hr,un,ne,we,wt,Qe,pr,kt,ur,mn,D,eo,mr,Tt,fr,gr,S,oo,_r,to,br,Mt,vr,yr,wr,x,kr,$t,Tr,Mr,Nt,$r,Nr,xt,xr,Er,Et,zr,qr,zt,Cr,Lr,qt,Fr,Pr,Sr,Ct,Ar,fn,ae,ke,Lt,no,jr,Ft,Or,gn,F,ao,Dr,ro,Gr,xo,Br,Ir,Rr,so,Hr,io,Wr,Jr,Ur,E,lo,Vr,re,Kr,Eo,Zr,Xr,Pt,Yr,Qr,es,Te,os,se,ts,zo,ns,as,St,rs,ss,is,Me,ls,$e,_n,ie,Ne,At,co,ds,jt,cs,bn,P,ho,hs,po,ps,qo,us,ms,fs,uo,gs,mo,_s,bs,vs,A,fo,ys,le,ws,Co,ks,Ts,Ot,Ms,$s,Ns,xe,xs,Ee,vn;return c=new G({}),Pe=new G({}),Oe=new G({}),De=new G({}),Be=new Rt({props:{code:`from transformers import AutoModelForSeq2SeqLM, AutoTokenizer

tokenizer = AutoTokenizer.from_pretrained("facebook/nllb-moe-54b")
model = AutoModelForSeq2SeqLM.from_pretrained("facebook/nllb-moe-54b")

article = "Previously, Ring's CEO, Jamie Siminoff, remarked the company started when his doorbell wasn't audible from his shop in his garage."
inputs = tokenizer(article, return_tensors="pt")

translated_tokens = model.generate(
    **inputs, forced_bos_token_id=tokenizer.lang_code_to_id["fra_Latn"], max_length=50
)
tokenizer.batch_decode(translated_tokens, skip_special_tokens=True)[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForSeq2SeqLM, AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;facebook/nllb-moe-54b&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForSeq2SeqLM.from_pretrained(<span class="hljs-string">&quot;facebook/nllb-moe-54b&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>article = <span class="hljs-string">&quot;Previously, Ring&#x27;s CEO, Jamie Siminoff, remarked the company started when his doorbell wasn&#x27;t audible from his shop in his garage.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(article, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>translated_tokens = model.generate(
<span class="hljs-meta">... </span>    **inputs, forced_bos_token_id=tokenizer.lang_code_to_id[<span class="hljs-string">&quot;fra_Latn&quot;</span>], max_length=<span class="hljs-number">50</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.batch_decode(translated_tokens, skip_special_tokens=<span class="hljs-literal">True</span>)[<span class="hljs-number">0</span>]
<span class="hljs-string">&quot;Auparavant, le PDG de Ring, Jamie Siminoff, a fait remarquer que la soci\xE9t\xE9 avait commenc\xE9 lorsque sa sonnette n&#x27;\xE9tait pas audible depuis son magasin dans son garage.&quot;</span>`}}),Ie=new G({}),Re=new Rt({props:{code:`from transformers import AutoModelForSeq2SeqLM, AutoTokenizer

tokenizer = AutoTokenizer.from_pretrained("facebook/nllb-moe-54b", src_lang="ron_Latn")
model = AutoModelForSeq2SeqLM.from_pretrained("facebook/nllb-moe-54b")

article = "\u015Eeful ONU spune c\u0103 nu exist\u0103 o solu\u0163ie militar\u0103 \xEEn Siria"
inputs = tokenizer(article, return_tensors="pt")

translated_tokens = model.generate(
    **inputs, forced_bos_token_id=tokenizer.lang_code_to_id["deu_Latn"], max_length=30
)
tokenizer.batch_decode(translated_tokens, skip_special_tokens=True)[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForSeq2SeqLM, AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;facebook/nllb-moe-54b&quot;</span>, src_lang=<span class="hljs-string">&quot;ron_Latn&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForSeq2SeqLM.from_pretrained(<span class="hljs-string">&quot;facebook/nllb-moe-54b&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>article = <span class="hljs-string">&quot;\u015Eeful ONU spune c\u0103 nu exist\u0103 o solu\u0163ie militar\u0103 \xEEn Siria&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(article, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>translated_tokens = model.generate(
<span class="hljs-meta">... </span>    **inputs, forced_bos_token_id=tokenizer.lang_code_to_id[<span class="hljs-string">&quot;deu_Latn&quot;</span>], max_length=<span class="hljs-number">30</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.batch_decode(translated_tokens, skip_special_tokens=<span class="hljs-literal">True</span>)[<span class="hljs-number">0</span>]`}}),He=new G({}),We=new G({}),Je=new J({props:{name:"class transformers.NllbMoeConfig",anchor:"transformers.NllbMoeConfig",parameters:[{name:"vocab_size",val:" = 128112"},{name:"max_position_embeddings",val:" = 1024"},{name:"encoder_layers",val:" = 12"},{name:"encoder_ffn_dim",val:" = 4096"},{name:"encoder_attention_heads",val:" = 16"},{name:"decoder_layers",val:" = 12"},{name:"decoder_ffn_dim",val:" = 4096"},{name:"decoder_attention_heads",val:" = 16"},{name:"encoder_layerdrop",val:" = 0.05"},{name:"decoder_layerdrop",val:" = 0.05"},{name:"use_cache",val:" = True"},{name:"is_encoder_decoder",val:" = True"},{name:"activation_function",val:" = 'relu'"},{name:"d_model",val:" = 1024"},{name:"dropout",val:" = 0.1"},{name:"attention_dropout",val:" = 0.1"},{name:"activation_dropout",val:" = 0.0"},{name:"init_std",val:" = 0.02"},{name:"decoder_start_token_id",val:" = 2"},{name:"scale_embedding",val:" = True"},{name:"router_bias",val:" = False"},{name:"router_dtype",val:" = 'float32'"},{name:"router_ignore_padding_tokens",val:" = False"},{name:"num_experts",val:" = 128"},{name:"expert_capacity",val:" = 64"},{name:"encoder_sparse_step",val:" = 4"},{name:"decoder_sparse_step",val:" = 4"},{name:"router_z_loss_coef",val:" = 0.001"},{name:"router_aux_loss_coef",val:" = 0.001"},{name:"second_expert_policy",val:" = 'all'"},{name:"normalize_router_prob_before_dropping",val:" = False"},{name:"batch_prioritized_routing",val:" = False"},{name:"moe_eval_capacity_token_fraction",val:" = 1.0"},{name:"moe_token_dropout",val:" = 0.2"},{name:"pad_token_id",val:" = 1"},{name:"bos_token_id",val:" = 0"},{name:"eos_token_id",val:" = 2"},{name:"output_router_logits",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.NllbMoeConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 50265) &#x2014;
Vocabulary size of the NllbMoe model. Defines the number of different tokens that can be represented by the
<code>inputs_ids</code> passed when calling <a href="/docs/transformers/main/en/model_doc/nllb-moe#transformers.NllbMoeModel">NllbMoeModel</a> or`,name:"vocab_size"},{anchor:"transformers.NllbMoeConfig.d_model",description:`<strong>d_model</strong> (<code>int</code>, <em>optional</em>, defaults to 1024) &#x2014;
Dimensionality of the layers and the pooler layer.`,name:"d_model"},{anchor:"transformers.NllbMoeConfig.encoder_layers",description:`<strong>encoder_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of encoder layers.`,name:"encoder_layers"},{anchor:"transformers.NllbMoeConfig.decoder_layers",description:`<strong>decoder_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of decoder layers.`,name:"decoder_layers"},{anchor:"transformers.NllbMoeConfig.encoder_attention_heads",description:`<strong>encoder_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"encoder_attention_heads"},{anchor:"transformers.NllbMoeConfig.decoder_attention_heads",description:`<strong>decoder_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
Number of attention heads for each attention layer in the Transformer decoder.`,name:"decoder_attention_heads"},{anchor:"transformers.NllbMoeConfig.decoder_ffn_dim",description:`<strong>decoder_ffn_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 4096) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in decoder.`,name:"decoder_ffn_dim"},{anchor:"transformers.NllbMoeConfig.encoder_ffn_dim",description:`<strong>encoder_ffn_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 4096) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in decoder.`,name:"encoder_ffn_dim"},{anchor:"transformers.NllbMoeConfig.activation_function",description:`<strong>activation_function</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;silu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"activation_function"},{anchor:"transformers.NllbMoeConfig.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for all fully connected layers in the embeddings, encoder, and pooler.`,name:"dropout"},{anchor:"transformers.NllbMoeConfig.attention_dropout",description:`<strong>attention_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_dropout"},{anchor:"transformers.NllbMoeConfig.activation_dropout",description:`<strong>activation_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for activations inside the fully connected layer.`,name:"activation_dropout"},{anchor:"transformers.NllbMoeConfig.classifier_dropout",description:`<strong>classifier_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for classifier.`,name:"classifier_dropout"},{anchor:"transformers.NllbMoeConfig.max_position_embeddings",description:`<strong>max_position_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 1024) &#x2014;
The maximum sequence length that this model might ever be used with. Typically set this to something large
just in case (e.g., 512 or 1024 or 2048).`,name:"max_position_embeddings"},{anchor:"transformers.NllbMoeConfig.init_std",description:`<strong>init_std</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"init_std"},{anchor:"transformers.NllbMoeConfig.encoder_layerdrop",description:`<strong>encoder_layerdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The LayerDrop probability for the encoder. See the [LayerDrop paper](see <a href="https://arxiv.org/abs/1909.11556" rel="nofollow">https://arxiv.org/abs/1909.11556</a>)
for more details.`,name:"encoder_layerdrop"},{anchor:"transformers.NllbMoeConfig.decoder_layerdrop",description:`<strong>decoder_layerdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The LayerDrop probability for the decoder. See the [LayerDrop paper](see <a href="https://arxiv.org/abs/1909.11556" rel="nofollow">https://arxiv.org/abs/1909.11556</a>)
for more details.`,name:"decoder_layerdrop"},{anchor:"transformers.NllbMoeConfig.second_expert_policy",description:`<strong>second_expert_policy</strong> ( <code>str</code>, <em>optional</em>, default to <code>&quot;all&quot;</code>) &#x2014;
The policy used for the sampling the probability of being sampled to a second expert for each token.`,name:"second_expert_policy"},{anchor:"transformers.NllbMoeConfig.normalize_router_prob_before_dropping",description:`<strong>normalize_router_prob_before_dropping</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to normalize the router probabilities before applying a mask based on the experts capacity
(capacity dropping).`,name:"normalize_router_prob_before_dropping"},{anchor:"transformers.NllbMoeConfig.batch_prioritized_routing",description:`<strong>batch_prioritized_routing</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to orders the tokens by their router probabilities before capacity dropping. This means that
the tokens that have the highest probabilities will be routed before other tokens that might be further in
the sequence.`,name:"batch_prioritized_routing"},{anchor:"transformers.NllbMoeConfig.moe_eval_capacity_token_fraction",description:`<strong>moe_eval_capacity_token_fraction</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
Fraction of tokens as capacity during validation, if set to negative, uses the same as training. Should be
in range: (0.0, 1.0].`,name:"moe_eval_capacity_token_fraction"},{anchor:"transformers.NllbMoeConfig.num_experts",description:`<strong>num_experts</strong> (<code>int</code>, <em>optional</em>, defaults to 128) &#x2014;
Number of experts for each NllbMoeSparseMlp layer.`,name:"num_experts"},{anchor:"transformers.NllbMoeConfig.expert_capacity",description:`<strong>expert_capacity</strong> (<code>int</code>, <em>optional</em>, defaults to 64) &#x2014;
Number of tokens that can be stored in each expert.`,name:"expert_capacity"},{anchor:"transformers.NllbMoeConfig.encoder_sparse_step",description:`<strong>encoder_sparse_step</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
Frequency of the sparse layers in the encoder. 4 means that one out of 4 layers will be sparse.`,name:"encoder_sparse_step"},{anchor:"transformers.NllbMoeConfig.decoder_sparse_step",description:`<strong>decoder_sparse_step</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
Frequency of the sparse layers in the decoder. 4 means that one out of 4 layers will be sparse.`,name:"decoder_sparse_step"},{anchor:"transformers.NllbMoeConfig.router_dtype",description:`<strong>router_dtype</strong> (<code>str</code>, <em>optional</em>, default to <code>&quot;float32&quot;</code>) &#x2014;
The <code>dtype</code> used for the routers. It is preferable to keep the <code>dtype</code> to <code>&quot;float32&quot;</code> as specified in the
<em>selective precision</em> discussion in <a href="https://arxiv.org/abs/2101.03961" rel="nofollow">the paper</a>.`,name:"router_dtype"},{anchor:"transformers.NllbMoeConfig.router_ignore_padding_tokens",description:`<strong>router_ignore_padding_tokens</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to ignore padding tokens when routing. if <code>False</code>, the padding tokens are not routed to any
experts.`,name:"router_ignore_padding_tokens"},{anchor:"transformers.NllbMoeConfig.router_bias",description:`<strong>router_bias</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the classifier of the router should have a bias.`,name:"router_bias"},{anchor:"transformers.NllbMoeConfig.moe_token_dropout",description:`<strong>moe_token_dropout</strong> (<code>float</code>, <em>optional</em>, defualt ot 0.2) &#x2014;
Masking rate for MoE expert output masking (EOM), which is implemented via a Dropout2d on the expert
outputs.`,name:"moe_token_dropout"},{anchor:"transformers.NllbMoeConfig.output_router_logits",description:`<strong>output_router_logits</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to return the router logits. Only set to <code>True</code> to get the auxiliary loss when training.`,name:"output_router_logits"},{anchor:"transformers.NllbMoeConfig.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the model should return the last key/values attentions (not used by all models).`,name:"use_cache"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/nllb_moe/configuration_nllb_moe.py#L27"}}),_e=new zs({props:{anchor:"transformers.NllbMoeConfig.example",$$slots:{default:[il]},$$scope:{ctx:z}}}),Ve=new G({}),Ke=new J({props:{name:"class transformers.NllbMoeTop2Router",anchor:"transformers.NllbMoeTop2Router",parameters:[{name:"config",val:": NllbMoeConfig"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/nllb_moe/modeling_nllb_moe.py#L249"}}),Xe=new J({props:{name:"route_tokens",anchor:"transformers.NllbMoeTop2Router.route_tokens",parameters:[{name:"router_logits",val:": Tensor"},{name:"input_dtype",val:": dtype = torch.float32"},{name:"padding_mask",val:": typing.Optional[torch.LongTensor] = None"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/nllb_moe/modeling_nllb_moe.py#L290"}}),Ye=new J({props:{name:"forward",anchor:"transformers.NllbMoeTop2Router.forward",parameters:[{name:"hidden_states",val:": Tensor"},{name:"padding_mask",val:": typing.Optional[torch.LongTensor] = None"}],parametersDescription:[{anchor:"transformers.NllbMoeTop2Router.forward.hidden_states",description:`<strong>hidden_states</strong> (<code>torch.Tensor</code>) &#x2014;
(batch_size, sequence_length, hidden_dim) from which router probabilities are computed.`,name:"hidden_states"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/nllb_moe/modeling_nllb_moe.py#L375",returnDescription:`
<p>Index tensor of shape [batch_size, sequence_length] corresponding to the expert selected for each token
using the top1 probabilities of the router.
router_probabilities (<code>torch.Tensor</code> of shape (batch_size, sequence_length, nump_experts)):
Tensor of shape (batch_size, sequence_length, num_experts) corresponding to the probabilities for each
token and expert. Used for routing tokens to experts.
router_logits (<code>torch.Tensor</code> of shape (batch_size, sequence_length))):
Logits tensor of shape (batch_size, sequence_length, num_experts) corresponding to raw router logits.
This is used later for computing router z-loss.</p>
`,returnType:`
<p>top_1_mask (<code>torch.Tensor</code> of shape (batch_size, sequence_length))</p>
`}}),Qe=new G({}),eo=new J({props:{name:"class transformers.NllbMoeSparseMLP",anchor:"transformers.NllbMoeSparseMLP",parameters:[{name:"config",val:": NllbMoeConfig"},{name:"ffn_dim",val:": int"},{name:"expert_class",val:": Module = <class 'transformers.models.nllb_moe.modeling_nllb_moe.NllbMoeDenseActDense'>"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/nllb_moe/modeling_nllb_moe.py#L426"}}),oo=new J({props:{name:"forward",anchor:"transformers.NllbMoeSparseMLP.forward",parameters:[{name:"hidden_states",val:": Tensor"},{name:"padding_mask",val:": typing.Optional[torch.Tensor] = False"}],parametersDescription:[{anchor:"transformers.NllbMoeSparseMLP.forward.hidden_states",description:`<strong>hidden_states</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_dim)</code>) &#x2014;
The hidden states`,name:"hidden_states"},{anchor:"transformers.NllbMoeSparseMLP.forward.padding_mask",description:`<strong>padding_mask</strong> (<code>torch.Tensor</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Attention mask. Can be in the causal form or not.`,name:"padding_mask"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/nllb_moe/modeling_nllb_moe.py#L442",returnDescription:`
<p>Updated hidden states
router_logits (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length, num_experts)</code>):
Needed for computing the loss</p>
`,returnType:`
<p>hidden_states (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_lenght, hidden_dim)</code>)</p>
`}}),no=new G({}),ao=new J({props:{name:"class transformers.NllbMoeModel",anchor:"transformers.NllbMoeModel",parameters:[{name:"config",val:": NllbMoeConfig"}],parametersDescription:[{anchor:"transformers.NllbMoeModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/nllb-moe#transformers.NllbMoeConfig">NllbMoeConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/nllb_moe/modeling_nllb_moe.py#L1503"}}),lo=new J({props:{name:"forward",anchor:"transformers.NllbMoeModel.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"decoder_input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"decoder_attention_mask",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"decoder_head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"cross_attn_head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"encoder_outputs",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"output_router_logits",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.NllbMoeModel.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Padding will be ignored by default should you provide
it.`,name:"input_ids"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/nllb_moe/modeling_nllb_moe.py#L1539",returnDescription:`
<p>A <code>transformers.modeling_outputs.Seq2SeqMoEModelOutput</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/nllb-moe#transformers.NllbMoeConfig"
>NllbMoeConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</p>
<p>If <code>past_key_values</code> is used only the last hidden-state of the sequences of shape <code>(batch_size, 1, hidden_size)</code> is output.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of shape
<code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the cross-attention
blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the decoder at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
<li>
<p><strong>decoder_router_logits</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_router_logits=True</code> is passed or when <code>config.add_router_probs=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, sequence_length, num_experts)</code>.</p>
<p>Router logits of the decoder model, useful to compute the auxiliary loss for Mixture of Experts models.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
<li>
<p><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</p>
</li>
<li>
<p><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the encoder at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the encoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
<li>
<p><strong>encoder_router_logits</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_router_logits=True</code> is passed or when <code>config.add_router_probs=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, sequence_length, num_experts)</code>.</p>
<p>Router logits of the encoder model, useful to compute the auxiliary loss and the z_loss for the sparse
modules.</p>
</li>
</ul>
`,returnType:`
<p><code>transformers.modeling_outputs.Seq2SeqMoEModelOutput</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Te=new Es({props:{$$slots:{default:[ll]},$$scope:{ctx:z}}}),Me=new Es({props:{$$slots:{default:[dl]},$$scope:{ctx:z}}}),$e=new zs({props:{anchor:"transformers.NllbMoeModel.forward.example",$$slots:{default:[cl]},$$scope:{ctx:z}}}),co=new G({}),ho=new J({props:{name:"class transformers.NllbMoeForConditionalGeneration",anchor:"transformers.NllbMoeForConditionalGeneration",parameters:[{name:"config",val:": NllbMoeConfig"}],parametersDescription:[{anchor:"transformers.NllbMoeForConditionalGeneration.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/nllb-moe#transformers.NllbMoeConfig">NllbMoeConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/nllb_moe/modeling_nllb_moe.py#L1642"}}),fo=new J({props:{name:"forward",anchor:"transformers.NllbMoeForConditionalGeneration.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"decoder_input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"decoder_attention_mask",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"decoder_head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"cross_attn_head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"encoder_outputs",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"output_router_logits",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.NllbMoeForConditionalGeneration.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Padding will be ignored by default should you provide
it.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#decoder-input-ids">What are decoder input IDs?</a></p>
<p>NllbMoe uses the <code>eos_token_id</code> as the starting token for <code>decoder_input_ids</code> generation. If
<code>past_key_values</code> is used, optionally only the last <code>decoder_input_ids</code> have to be input (see
<code>past_key_values</code>).`,name:"decoder_input_ids"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.`,name:"decoder_attention_mask"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.Tensor</code> of shape <code>(encoder_layers, encoder_attention_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the attention modules in the encoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.decoder_head_mask",description:`<strong>decoder_head_mask</strong> (<code>torch.Tensor</code> of shape <code>(decoder_layers, decoder_attention_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the attention modules in the decoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"decoder_head_mask"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.cross_attn_head_mask",description:`<strong>cross_attn_head_mask</strong> (<code>torch.Tensor</code> of shape <code>(decoder_layers, decoder_attention_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the cross-attention modules in the decoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"cross_attn_head_mask"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) &#x2014;
Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of shape
<code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the cross-attention
blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>. inputs_embeds (<code>torch.FloatTensor</code> of shape
<code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>): Optionally, instead of passing <code>input_ids</code> you
can choose to directly pass an embedded representation. This is useful if you want more control over how to
convert <code>input_ids</code> indices into associated vectors than the model&#x2019;s internal embedding lookup matrix.`,name:"past_key_values"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, target_sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>decoder_input_ids</code> you can choose to directly pass an embedded
representation. If <code>past_key_values</code> is used, optionally only the last <code>decoder_inputs_embeds</code> have to be
input (see <code>past_key_values</code>). This is useful if you want more control over how to convert
<code>decoder_input_ids</code> indices into associated vectors than the model&#x2019;s internal embedding lookup matrix.</p>
<p>If <code>decoder_input_ids</code> and <code>decoder_inputs_embeds</code> are both unset, <code>decoder_inputs_embeds</code> takes the value
of <code>inputs_embeds</code>.`,name:"decoder_inputs_embeds"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.output_router_logits",description:`<strong>output_router_logits</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the logits of all the routers. They are useful for computing the router loss, and
should not be returned during inference.`,name:"output_router_logits"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.NllbMoeForConditionalGeneration.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the masked language modeling loss. Indices should either be in <code>[0, ..., config.vocab_size]</code> or -100 (see <code>input_ids</code> docstring). Tokens with indices set to <code>-100</code> are ignored
(masked), the loss is only computed for the tokens with labels in <code>[0, ..., config.vocab_size]</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/nllb_moe/modeling_nllb_moe.py#L1682",returnDescription:`
<p>A <code>transformers.modeling_outputs.Seq2SeqMoEOutput</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/nllb-moe#transformers.NllbMoeConfig"
>NllbMoeConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Language modeling loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of shape
<code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the cross-attention
blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the decoder at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
<li>
<p><strong>decoder_router_logits</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_router_logits=True</code> is passed or when <code>config.add_router_probs=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, sequence_length, num_experts)</code>.</p>
<p>Router logits of the decoder model, useful to compute the auxiliary loss for Mixture of Experts models.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
<li>
<p><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</p>
</li>
<li>
<p><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the encoder at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the encoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
<li>
<p><strong>encoder_router_logits</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_router_logits=True</code> is passed or when <code>config.add_router_probs=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, sequence_length, num_experts)</code>.</p>
<p>Router logits of the encoder model, useful to compute the auxiliary loss and z_loss for Mixture of Experts
models.</p>
</li>
</ul>
`,returnType:`
<p><code>transformers.modeling_outputs.Seq2SeqMoEOutput</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),xe=new Es({props:{$$slots:{default:[hl]},$$scope:{ctx:z}}}),Ee=new zs({props:{anchor:"transformers.NllbMoeForConditionalGeneration.forward.example",$$slots:{default:[pl]},$$scope:{ctx:z}}}),{c(){m=n("meta"),$=h(),_=n("h1"),g=n("a"),b=n("span"),v(c.$$.fragment),f=h(),q=n("span"),Dn=s("NLLB-MOE"),Ht=h(),U=n("h2"),de=n("a"),Ho=n("span"),v(Pe.$$.fragment),Gn=h(),Wo=n("span"),Bn=s("Overview"),Wt=h(),ce=n("p"),In=s("The NLLB model was presented in "),Se=n("a"),Rn=s("No Language Left Behind: Scaling Human-Centered Machine Translation"),Hn=s(` by Marta R. Costa-juss\xE0, James Cross, Onur \xC7elebi,
Maha Elbayad, Kenneth Heafield, Kevin Heffernan, Elahe Kalbassi, Janice Lam, Daniel Licht, Jean Maillard, Anna Sun, Skyler Wang, Guillaume Wenzek, Al Youngblood, Bapi Akula,
Loic Barrault, Gabriel Mejia Gonzalez, Prangthip Hansanti, John Hoffman, Semarley Jarrett, Kaushik Ram Sadagopan, Dirk Rowe, Shannon Spruit, Chau Tran, Pierre Andrews,
Necip Fazil Ayan, Shruti Bhosale, Sergey Edunov, Angela Fan, Cynthia Gao, Vedanuj Goswami, Francisco Guzm\xE1n, Philipp Koehn, Alexandre Mourachko, Christophe Ropers,
Safiyyah Saleem, Holger Schwenk, and Jeff Wang.`),Jt=h(),bo=n("p"),Wn=s("The abstract of the paper is the following:"),Ut=h(),vo=n("p"),Jo=n("em"),Jn=s(`Driven by the goal of eradicating language barriers on a global scale, machine translation has solidified itself as a key focus of artificial intelligence research today.
However, such efforts have coalesced around a small subset of languages, leaving behind the vast majority of mostly low-resource languages. What does it take to break the
200 language barrier while ensuring safe, high quality results, all while keeping ethical considerations in mind? In No Language Left Behind, we took on this challenge by
first contextualizing the need for low-resource language translation support through exploratory interviews with native speakers. Then, we created datasets and models aimed
at narrowing the performance gap between low and high-resource languages. More specifically, we developed a conditional compute model based on Sparsely Gated Mixture of
Experts that is trained on data obtained with novel and effective data mining techniques tailored for low-resource languages. We propose multiple architectural and training
improvements to counteract overfitting while training on thousands of tasks. Critically, we evaluated the performance of over 40,000 different translation directions using
a human-translated benchmark, Flores-200, and combined human evaluation with a novel toxicity benchmark covering all languages in Flores-200 to assess translation safety.
Our model achieves an improvement of 44% BLEU relative to the previous state-of-the-art, laying important groundwork towards realizing a universal translation system.`),Vt=h(),yo=n("p"),Un=s("Tips:"),Kt=h(),B=n("ul"),Uo=n("li"),Vn=s("M2M100ForConditionalGeneration is the base model for both NLLB and NLLB MoE"),Kn=h(),Vo=n("li"),Zn=s("The NLLB-MoE is very similar to the NLLB model, but it\u2019s feed forward layer is based on the implementation of SwitchTransformers."),Xn=h(),Ko=n("li"),Yn=s("The tokenizer is the same as the NLLB models."),Zt=h(),I=n("p"),Qn=s("This model was contributed by "),Ae=n("a"),ea=s("Arthur Zucker"),oa=s(`.
The original code can be found `),je=n("a"),ta=s("here"),na=s("."),Xt=h(),V=n("h2"),he=n("a"),Zo=n("span"),v(Oe.$$.fragment),aa=h(),Xo=n("span"),ra=s("Implementation differences with SwitchTransformers"),Yt=s(`

The biggest difference is the way the tokens are routed. NLLB-MoE uses a \`top-2-gate\` which means that blah blah blah blah. 
In SwitchTransformers, once the masks are computed for each experts, we just index the current hidden_states with the routing mask, and feed the 
correct tokens to the expert. However here, the implementation varies a lot as the fairseq repository used a different approach.
`),K=n("h2"),pe=n("a"),Yo=n("span"),v(De.$$.fragment),sa=h(),Qo=n("span"),ia=s("Generating with NLLB-MoE"),Qt=s(`

The avalable checkpoints requires around 350GB of storage. Make sure to use \`accelerate\` if you do not have enough RAM on your machine.
`),R=n("p"),la=s("While generating the target text set the "),et=n("code"),da=s("forced_bos_token_id"),ca=s(` to the target language id. The following
example shows how to translate English to French using the `),ot=n("em"),ha=s("facebook/nllb-200-distilled-600M"),pa=s(" model."),en=h(),H=n("p"),ua=s("Note that we\u2019re using the BCP-47 code for French "),tt=n("code"),ma=s("fra_Latn"),fa=s(". See "),Ge=n("a"),ga=s("here"),_a=s(`
for the list of all BCP-47 in the Flores 200 dataset.`),on=h(),v(Be.$$.fragment),tn=h(),Z=n("h3"),ue=n("a"),nt=n("span"),v(Ie.$$.fragment),ba=h(),at=n("span"),va=s("Generating from any other language than English"),nn=h(),W=n("p"),ya=s("English ("),rt=n("code"),wa=s("eng_Latn"),ka=s(`) is set as the default language from which to translate. In order to specify that you\u2019d like to translate from a different language,
you should specify the BCP-47 code in the `),st=n("code"),Ta=s("src_lang"),Ma=s(" keyword argument of the tokenizer initialization."),an=h(),wo=n("p"),$a=s("See example below for a translation from romanian to german:"),rn=h(),v(Re.$$.fragment),sn=h(),X=n("h2"),me=n("a"),it=n("span"),v(He.$$.fragment),Na=h(),lt=n("span"),xa=s("Documentation resources"),ln=h(),fe=n("ul"),dt=n("li"),ko=n("a"),Ea=s("Translation task guide"),za=h(),ct=n("li"),To=n("a"),qa=s("Summarization task guide"),dn=h(),Y=n("h2"),ge=n("a"),ht=n("span"),v(We.$$.fragment),Ca=h(),pt=n("span"),La=s("NllbMoeConfig"),cn=h(),L=n("div"),v(Je.$$.fragment),Fa=h(),Q=n("p"),Pa=s("This is the configuration class to store the configuration of a "),Mo=n("a"),Sa=s("NllbMoeModel"),Aa=s(`. It is used to instantiate an
NLLB-MoE model according to the specified arguments, defining the model architecture. Instantiating a configuration
with the defaults will yield a similar configuration to that of the NLLB-MoE
`),Ue=n("a"),ja=s("facebook/nllb-moe-54b"),Oa=s(" architecture."),Da=h(),ee=n("p"),Ga=s("Configuration objects inherit from "),$o=n("a"),Ba=s("PretrainedConfig"),Ia=s(` and can be used to control the model outputs. Read the
documentation from `),No=n("a"),Ra=s("PretrainedConfig"),Ha=s(" for more information."),Wa=h(),v(_e.$$.fragment),hn=h(),oe=n("h2"),be=n("a"),ut=n("span"),v(Ve.$$.fragment),Ja=h(),mt=n("span"),Ua=s("NllbMoeTop2Router"),pn=h(),N=n("div"),v(Ke.$$.fragment),Va=h(),ft=n("p"),Ka=s("Router using tokens choose top-2 experts assignment."),Za=h(),Ze=n("p"),Xa=s(`This router uses the same mechanism as in NLLB-MoE from the fairseq repository. Items are sorted by router_probs
and then routed to their choice of expert until the expert\u2019s expert_capacity is reached. `),gt=n("strong"),Ya=s(`There is no guarantee
that each token is processed by an expert`),Qa=s(", or that each expert receives at least one token."),er=h(),_t=n("p"),or=s("The router combining weights are also returned to make sure that the states that are not updated will be masked."),tr=h(),ve=n("div"),v(Xe.$$.fragment),nr=h(),te=n("p"),ar=s("Computes the "),bt=n("code"),rr=s("dispatch_mask"),sr=s(" and the "),vt=n("code"),ir=s("dispatch_weights"),lr=s(` for each experts. The masks are adapted to the expert
capacity.`),dr=h(),ye=n("div"),v(Ye.$$.fragment),cr=h(),yt=n("p"),hr=s(`The hidden states are reshaped to simplify the computation of the router probabilities (combining weights for
each experts.)`),un=h(),ne=n("h2"),we=n("a"),wt=n("span"),v(Qe.$$.fragment),pr=h(),kt=n("span"),ur=s("NllbMoeSparseMLP"),mn=h(),D=n("div"),v(eo.$$.fragment),mr=h(),Tt=n("p"),fr=s("Implementation of the NLLB-MoE sparse MLP module."),gr=h(),S=n("div"),v(oo.$$.fragment),_r=h(),to=n("p"),br=s("The goal of this forward pass is to have the same number of operation as the equivalent "),Mt=n("code"),vr=s("NllbMoeDenseActDense"),yr=s(`
(mlp) layer. This means that all of the hidden states should be processed at most twice ( since we are using a
top_2 gating mecanism). This means that we keep the complexity to O(batch_size x sequence_length x hidden_dim)
instead of O(num_experts x batch_size x sequence_length x hidden_dim).`),wr=h(),x=n("p"),kr=s("1- Get the "),$t=n("code"),Tr=s("router_probs"),Mr=s(" from the "),Nt=n("code"),$r=s("router"),Nr=s(". The shape of the "),xt=n("code"),xr=s("router_mask"),Er=s(" is "),Et=n("code"),zr=s("(batch_size X sequence_length, num_expert)"),qr=s(" and corresponds to the boolean version of the "),zt=n("code"),Cr=s("router_probs"),Lr=s(`. The inputs are masked using the
`),qt=n("code"),Fr=s("router_mask"),Pr=s("."),Sr=h(),Ct=n("p"),Ar=s(`2- Dispatch the hidden_states to its associated experts. The router probabilities are used to weight the
contribution of each experts when updating the masked hidden states.`),fn=h(),ae=n("h2"),ke=n("a"),Lt=n("span"),v(no.$$.fragment),jr=h(),Ft=n("span"),Or=s("NllbMoeModel"),gn=h(),F=n("div"),v(ao.$$.fragment),Dr=h(),ro=n("p"),Gr=s(`The bare NllbMoe Model outputting raw hidden-states without any specific head on top.
This model inherits from `),xo=n("a"),Br=s("PreTrainedModel"),Ir=s(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Rr=h(),so=n("p"),Hr=s("This model is also a PyTorch "),io=n("a"),Wr=s("torch.nn.Module"),Jr=s(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Ur=h(),E=n("div"),v(lo.$$.fragment),Vr=h(),re=n("p"),Kr=s("The "),Eo=n("a"),Zr=s("NllbMoeModel"),Xr=s(" forward method, overrides the "),Pt=n("code"),Yr=s("__call__"),Qr=s(" special method."),es=h(),v(Te.$$.fragment),os=h(),se=n("p"),ts=s("The "),zo=n("a"),ns=s("NllbMoeModel"),as=s(" forward method, overrides the "),St=n("code"),rs=s("__call__"),ss=s(" special method."),is=h(),v(Me.$$.fragment),ls=h(),v($e.$$.fragment),_n=h(),ie=n("h2"),Ne=n("a"),At=n("span"),v(co.$$.fragment),ds=h(),jt=n("span"),cs=s("NllbMoeForConditionalGeneration"),bn=h(),P=n("div"),v(ho.$$.fragment),hs=h(),po=n("p"),ps=s(`The NllbMoe Model with a language modeling head. Can be used for summarization.
This model inherits from `),qo=n("a"),us=s("PreTrainedModel"),ms=s(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),fs=h(),uo=n("p"),gs=s("This model is also a PyTorch "),mo=n("a"),_s=s("torch.nn.Module"),bs=s(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),vs=h(),A=n("div"),v(fo.$$.fragment),ys=h(),le=n("p"),ws=s("The "),Co=n("a"),ks=s("NllbMoeForConditionalGeneration"),Ts=s(" forward method, overrides the "),Ot=n("code"),Ms=s("__call__"),$s=s(" special method."),Ns=h(),v(xe.$$.fragment),xs=h(),v(Ee.$$.fragment),this.h()},l(o){const d=rl('[data-svelte="svelte-1phssyn"]',document.head);m=a(d,"META",{name:!0,content:!0}),d.forEach(t),$=p(o),_=a(o,"H1",{class:!0});var go=r(_);g=a(go,"A",{id:!0,class:!0,href:!0});var Dt=r(g);b=a(Dt,"SPAN",{});var Gt=r(b);y(c.$$.fragment,Gt),Gt.forEach(t),Dt.forEach(t),f=p(go),q=a(go,"SPAN",{});var Bt=r(q);Dn=i(Bt,"NLLB-MOE"),Bt.forEach(t),go.forEach(t),Ht=p(o),U=a(o,"H2",{class:!0});var _o=r(U);de=a(_o,"A",{id:!0,class:!0,href:!0});var It=r(de);Ho=a(It,"SPAN",{});var Cs=r(Ho);y(Pe.$$.fragment,Cs),Cs.forEach(t),It.forEach(t),Gn=p(_o),Wo=a(_o,"SPAN",{});var Ls=r(Wo);Bn=i(Ls,"Overview"),Ls.forEach(t),_o.forEach(t),Wt=p(o),ce=a(o,"P",{});var yn=r(ce);In=i(yn,"The NLLB model was presented in "),Se=a(yn,"A",{href:!0,rel:!0});var Fs=r(Se);Rn=i(Fs,"No Language Left Behind: Scaling Human-Centered Machine Translation"),Fs.forEach(t),Hn=i(yn,` by Marta R. Costa-juss\xE0, James Cross, Onur \xC7elebi,
Maha Elbayad, Kenneth Heafield, Kevin Heffernan, Elahe Kalbassi, Janice Lam, Daniel Licht, Jean Maillard, Anna Sun, Skyler Wang, Guillaume Wenzek, Al Youngblood, Bapi Akula,
Loic Barrault, Gabriel Mejia Gonzalez, Prangthip Hansanti, John Hoffman, Semarley Jarrett, Kaushik Ram Sadagopan, Dirk Rowe, Shannon Spruit, Chau Tran, Pierre Andrews,
Necip Fazil Ayan, Shruti Bhosale, Sergey Edunov, Angela Fan, Cynthia Gao, Vedanuj Goswami, Francisco Guzm\xE1n, Philipp Koehn, Alexandre Mourachko, Christophe Ropers,
Safiyyah Saleem, Holger Schwenk, and Jeff Wang.`),yn.forEach(t),Jt=p(o),bo=a(o,"P",{});var Ps=r(bo);Wn=i(Ps,"The abstract of the paper is the following:"),Ps.forEach(t),Ut=p(o),vo=a(o,"P",{});var Ss=r(vo);Jo=a(Ss,"EM",{});var As=r(Jo);Jn=i(As,`Driven by the goal of eradicating language barriers on a global scale, machine translation has solidified itself as a key focus of artificial intelligence research today.
However, such efforts have coalesced around a small subset of languages, leaving behind the vast majority of mostly low-resource languages. What does it take to break the
200 language barrier while ensuring safe, high quality results, all while keeping ethical considerations in mind? In No Language Left Behind, we took on this challenge by
first contextualizing the need for low-resource language translation support through exploratory interviews with native speakers. Then, we created datasets and models aimed
at narrowing the performance gap between low and high-resource languages. More specifically, we developed a conditional compute model based on Sparsely Gated Mixture of
Experts that is trained on data obtained with novel and effective data mining techniques tailored for low-resource languages. We propose multiple architectural and training
improvements to counteract overfitting while training on thousands of tasks. Critically, we evaluated the performance of over 40,000 different translation directions using
a human-translated benchmark, Flores-200, and combined human evaluation with a novel toxicity benchmark covering all languages in Flores-200 to assess translation safety.
Our model achieves an improvement of 44% BLEU relative to the previous state-of-the-art, laying important groundwork towards realizing a universal translation system.`),As.forEach(t),Ss.forEach(t),Vt=p(o),yo=a(o,"P",{});var js=r(yo);Un=i(js,"Tips:"),js.forEach(t),Kt=p(o),B=a(o,"UL",{});var Lo=r(B);Uo=a(Lo,"LI",{});var Os=r(Uo);Vn=i(Os,"M2M100ForConditionalGeneration is the base model for both NLLB and NLLB MoE"),Os.forEach(t),Kn=p(Lo),Vo=a(Lo,"LI",{});var Ds=r(Vo);Zn=i(Ds,"The NLLB-MoE is very similar to the NLLB model, but it\u2019s feed forward layer is based on the implementation of SwitchTransformers."),Ds.forEach(t),Xn=p(Lo),Ko=a(Lo,"LI",{});var Gs=r(Ko);Yn=i(Gs,"The tokenizer is the same as the NLLB models."),Gs.forEach(t),Lo.forEach(t),Zt=p(o),I=a(o,"P",{});var Fo=r(I);Qn=i(Fo,"This model was contributed by "),Ae=a(Fo,"A",{href:!0,rel:!0});var Bs=r(Ae);ea=i(Bs,"Arthur Zucker"),Bs.forEach(t),oa=i(Fo,`.
The original code can be found `),je=a(Fo,"A",{href:!0,rel:!0});var Is=r(je);ta=i(Is,"here"),Is.forEach(t),na=i(Fo,"."),Fo.forEach(t),Xt=p(o),V=a(o,"H2",{class:!0});var wn=r(V);he=a(wn,"A",{id:!0,class:!0,href:!0});var Rs=r(he);Zo=a(Rs,"SPAN",{});var Hs=r(Zo);y(Oe.$$.fragment,Hs),Hs.forEach(t),Rs.forEach(t),aa=p(wn),Xo=a(wn,"SPAN",{});var Ws=r(Xo);ra=i(Ws,"Implementation differences with SwitchTransformers"),Ws.forEach(t),wn.forEach(t),Yt=i(o,`

The biggest difference is the way the tokens are routed. NLLB-MoE uses a \`top-2-gate\` which means that blah blah blah blah. 
In SwitchTransformers, once the masks are computed for each experts, we just index the current hidden_states with the routing mask, and feed the 
correct tokens to the expert. However here, the implementation varies a lot as the fairseq repository used a different approach.
`),K=a(o,"H2",{class:!0});var kn=r(K);pe=a(kn,"A",{id:!0,class:!0,href:!0});var Js=r(pe);Yo=a(Js,"SPAN",{});var Us=r(Yo);y(De.$$.fragment,Us),Us.forEach(t),Js.forEach(t),sa=p(kn),Qo=a(kn,"SPAN",{});var Vs=r(Qo);ia=i(Vs,"Generating with NLLB-MoE"),Vs.forEach(t),kn.forEach(t),Qt=i(o,`

The avalable checkpoints requires around 350GB of storage. Make sure to use \`accelerate\` if you do not have enough RAM on your machine.
`),R=a(o,"P",{});var Po=r(R);la=i(Po,"While generating the target text set the "),et=a(Po,"CODE",{});var Ks=r(et);da=i(Ks,"forced_bos_token_id"),Ks.forEach(t),ca=i(Po,` to the target language id. The following
example shows how to translate English to French using the `),ot=a(Po,"EM",{});var Zs=r(ot);ha=i(Zs,"facebook/nllb-200-distilled-600M"),Zs.forEach(t),pa=i(Po," model."),Po.forEach(t),en=p(o),H=a(o,"P",{});var So=r(H);ua=i(So,"Note that we\u2019re using the BCP-47 code for French "),tt=a(So,"CODE",{});var Xs=r(tt);ma=i(Xs,"fra_Latn"),Xs.forEach(t),fa=i(So,". See "),Ge=a(So,"A",{href:!0,rel:!0});var Ys=r(Ge);ga=i(Ys,"here"),Ys.forEach(t),_a=i(So,`
for the list of all BCP-47 in the Flores 200 dataset.`),So.forEach(t),on=p(o),y(Be.$$.fragment,o),tn=p(o),Z=a(o,"H3",{class:!0});var Tn=r(Z);ue=a(Tn,"A",{id:!0,class:!0,href:!0});var Qs=r(ue);nt=a(Qs,"SPAN",{});var ei=r(nt);y(Ie.$$.fragment,ei),ei.forEach(t),Qs.forEach(t),ba=p(Tn),at=a(Tn,"SPAN",{});var oi=r(at);va=i(oi,"Generating from any other language than English"),oi.forEach(t),Tn.forEach(t),nn=p(o),W=a(o,"P",{});var Ao=r(W);ya=i(Ao,"English ("),rt=a(Ao,"CODE",{});var ti=r(rt);wa=i(ti,"eng_Latn"),ti.forEach(t),ka=i(Ao,`) is set as the default language from which to translate. In order to specify that you\u2019d like to translate from a different language,
you should specify the BCP-47 code in the `),st=a(Ao,"CODE",{});var ni=r(st);Ta=i(ni,"src_lang"),ni.forEach(t),Ma=i(Ao," keyword argument of the tokenizer initialization."),Ao.forEach(t),an=p(o),wo=a(o,"P",{});var ai=r(wo);$a=i(ai,"See example below for a translation from romanian to german:"),ai.forEach(t),rn=p(o),y(Re.$$.fragment,o),sn=p(o),X=a(o,"H2",{class:!0});var Mn=r(X);me=a(Mn,"A",{id:!0,class:!0,href:!0});var ri=r(me);it=a(ri,"SPAN",{});var si=r(it);y(He.$$.fragment,si),si.forEach(t),ri.forEach(t),Na=p(Mn),lt=a(Mn,"SPAN",{});var ii=r(lt);xa=i(ii,"Documentation resources"),ii.forEach(t),Mn.forEach(t),ln=p(o),fe=a(o,"UL",{});var $n=r(fe);dt=a($n,"LI",{});var li=r(dt);ko=a(li,"A",{href:!0});var di=r(ko);Ea=i(di,"Translation task guide"),di.forEach(t),li.forEach(t),za=p($n),ct=a($n,"LI",{});var ci=r(ct);To=a(ci,"A",{href:!0});var hi=r(To);qa=i(hi,"Summarization task guide"),hi.forEach(t),ci.forEach(t),$n.forEach(t),dn=p(o),Y=a(o,"H2",{class:!0});var Nn=r(Y);ge=a(Nn,"A",{id:!0,class:!0,href:!0});var pi=r(ge);ht=a(pi,"SPAN",{});var ui=r(ht);y(We.$$.fragment,ui),ui.forEach(t),pi.forEach(t),Ca=p(Nn),pt=a(Nn,"SPAN",{});var mi=r(pt);La=i(mi,"NllbMoeConfig"),mi.forEach(t),Nn.forEach(t),cn=p(o),L=a(o,"DIV",{class:!0});var ze=r(L);y(Je.$$.fragment,ze),Fa=p(ze),Q=a(ze,"P",{});var jo=r(Q);Pa=i(jo,"This is the configuration class to store the configuration of a "),Mo=a(jo,"A",{href:!0});var fi=r(Mo);Sa=i(fi,"NllbMoeModel"),fi.forEach(t),Aa=i(jo,`. It is used to instantiate an
NLLB-MoE model according to the specified arguments, defining the model architecture. Instantiating a configuration
with the defaults will yield a similar configuration to that of the NLLB-MoE
`),Ue=a(jo,"A",{href:!0,rel:!0});var gi=r(Ue);ja=i(gi,"facebook/nllb-moe-54b"),gi.forEach(t),Oa=i(jo," architecture."),jo.forEach(t),Da=p(ze),ee=a(ze,"P",{});var Oo=r(ee);Ga=i(Oo,"Configuration objects inherit from "),$o=a(Oo,"A",{href:!0});var _i=r($o);Ba=i(_i,"PretrainedConfig"),_i.forEach(t),Ia=i(Oo,` and can be used to control the model outputs. Read the
documentation from `),No=a(Oo,"A",{href:!0});var bi=r(No);Ra=i(bi,"PretrainedConfig"),bi.forEach(t),Ha=i(Oo," for more information."),Oo.forEach(t),Wa=p(ze),y(_e.$$.fragment,ze),ze.forEach(t),hn=p(o),oe=a(o,"H2",{class:!0});var xn=r(oe);be=a(xn,"A",{id:!0,class:!0,href:!0});var vi=r(be);ut=a(vi,"SPAN",{});var yi=r(ut);y(Ve.$$.fragment,yi),yi.forEach(t),vi.forEach(t),Ja=p(xn),mt=a(xn,"SPAN",{});var wi=r(mt);Ua=i(wi,"NllbMoeTop2Router"),wi.forEach(t),xn.forEach(t),pn=p(o),N=a(o,"DIV",{class:!0});var j=r(N);y(Ke.$$.fragment,j),Va=p(j),ft=a(j,"P",{});var ki=r(ft);Ka=i(ki,"Router using tokens choose top-2 experts assignment."),ki.forEach(t),Za=p(j),Ze=a(j,"P",{});var En=r(Ze);Xa=i(En,`This router uses the same mechanism as in NLLB-MoE from the fairseq repository. Items are sorted by router_probs
and then routed to their choice of expert until the expert\u2019s expert_capacity is reached. `),gt=a(En,"STRONG",{});var Ti=r(gt);Ya=i(Ti,`There is no guarantee
that each token is processed by an expert`),Ti.forEach(t),Qa=i(En,", or that each expert receives at least one token."),En.forEach(t),er=p(j),_t=a(j,"P",{});var Mi=r(_t);or=i(Mi,"The router combining weights are also returned to make sure that the states that are not updated will be masked."),Mi.forEach(t),tr=p(j),ve=a(j,"DIV",{class:!0});var zn=r(ve);y(Xe.$$.fragment,zn),nr=p(zn),te=a(zn,"P",{});var Do=r(te);ar=i(Do,"Computes the "),bt=a(Do,"CODE",{});var $i=r(bt);rr=i($i,"dispatch_mask"),$i.forEach(t),sr=i(Do," and the "),vt=a(Do,"CODE",{});var Ni=r(vt);ir=i(Ni,"dispatch_weights"),Ni.forEach(t),lr=i(Do,` for each experts. The masks are adapted to the expert
capacity.`),Do.forEach(t),zn.forEach(t),dr=p(j),ye=a(j,"DIV",{class:!0});var qn=r(ye);y(Ye.$$.fragment,qn),cr=p(qn),yt=a(qn,"P",{});var xi=r(yt);hr=i(xi,`The hidden states are reshaped to simplify the computation of the router probabilities (combining weights for
each experts.)`),xi.forEach(t),qn.forEach(t),j.forEach(t),un=p(o),ne=a(o,"H2",{class:!0});var Cn=r(ne);we=a(Cn,"A",{id:!0,class:!0,href:!0});var Ei=r(we);wt=a(Ei,"SPAN",{});var zi=r(wt);y(Qe.$$.fragment,zi),zi.forEach(t),Ei.forEach(t),pr=p(Cn),kt=a(Cn,"SPAN",{});var qi=r(kt);ur=i(qi,"NllbMoeSparseMLP"),qi.forEach(t),Cn.forEach(t),mn=p(o),D=a(o,"DIV",{class:!0});var Go=r(D);y(eo.$$.fragment,Go),mr=p(Go),Tt=a(Go,"P",{});var Ci=r(Tt);fr=i(Ci,"Implementation of the NLLB-MoE sparse MLP module."),Ci.forEach(t),gr=p(Go),S=a(Go,"DIV",{class:!0});var qe=r(S);y(oo.$$.fragment,qe),_r=p(qe),to=a(qe,"P",{});var Ln=r(to);br=i(Ln,"The goal of this forward pass is to have the same number of operation as the equivalent "),Mt=a(Ln,"CODE",{});var Li=r(Mt);vr=i(Li,"NllbMoeDenseActDense"),Li.forEach(t),yr=i(Ln,`
(mlp) layer. This means that all of the hidden states should be processed at most twice ( since we are using a
top_2 gating mecanism). This means that we keep the complexity to O(batch_size x sequence_length x hidden_dim)
instead of O(num_experts x batch_size x sequence_length x hidden_dim).`),Ln.forEach(t),wr=p(qe),x=a(qe,"P",{});var C=r(x);kr=i(C,"1- Get the "),$t=a(C,"CODE",{});var Fi=r($t);Tr=i(Fi,"router_probs"),Fi.forEach(t),Mr=i(C," from the "),Nt=a(C,"CODE",{});var Pi=r(Nt);$r=i(Pi,"router"),Pi.forEach(t),Nr=i(C,". The shape of the "),xt=a(C,"CODE",{});var Si=r(xt);xr=i(Si,"router_mask"),Si.forEach(t),Er=i(C," is "),Et=a(C,"CODE",{});var Ai=r(Et);zr=i(Ai,"(batch_size X sequence_length, num_expert)"),Ai.forEach(t),qr=i(C," and corresponds to the boolean version of the "),zt=a(C,"CODE",{});var ji=r(zt);Cr=i(ji,"router_probs"),ji.forEach(t),Lr=i(C,`. The inputs are masked using the
`),qt=a(C,"CODE",{});var Oi=r(qt);Fr=i(Oi,"router_mask"),Oi.forEach(t),Pr=i(C,"."),C.forEach(t),Sr=p(qe),Ct=a(qe,"P",{});var Di=r(Ct);Ar=i(Di,`2- Dispatch the hidden_states to its associated experts. The router probabilities are used to weight the
contribution of each experts when updating the masked hidden states.`),Di.forEach(t),qe.forEach(t),Go.forEach(t),fn=p(o),ae=a(o,"H2",{class:!0});var Fn=r(ae);ke=a(Fn,"A",{id:!0,class:!0,href:!0});var Gi=r(ke);Lt=a(Gi,"SPAN",{});var Bi=r(Lt);y(no.$$.fragment,Bi),Bi.forEach(t),Gi.forEach(t),jr=p(Fn),Ft=a(Fn,"SPAN",{});var Ii=r(Ft);Or=i(Ii,"NllbMoeModel"),Ii.forEach(t),Fn.forEach(t),gn=p(o),F=a(o,"DIV",{class:!0});var Ce=r(F);y(ao.$$.fragment,Ce),Dr=p(Ce),ro=a(Ce,"P",{});var Pn=r(ro);Gr=i(Pn,`The bare NllbMoe Model outputting raw hidden-states without any specific head on top.
This model inherits from `),xo=a(Pn,"A",{href:!0});var Ri=r(xo);Br=i(Ri,"PreTrainedModel"),Ri.forEach(t),Ir=i(Pn,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Pn.forEach(t),Rr=p(Ce),so=a(Ce,"P",{});var Sn=r(so);Hr=i(Sn,"This model is also a PyTorch "),io=a(Sn,"A",{href:!0,rel:!0});var Hi=r(io);Wr=i(Hi,"torch.nn.Module"),Hi.forEach(t),Jr=i(Sn,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Sn.forEach(t),Ur=p(Ce),E=a(Ce,"DIV",{class:!0});var O=r(E);y(lo.$$.fragment,O),Vr=p(O),re=a(O,"P",{});var Bo=r(re);Kr=i(Bo,"The "),Eo=a(Bo,"A",{href:!0});var Wi=r(Eo);Zr=i(Wi,"NllbMoeModel"),Wi.forEach(t),Xr=i(Bo," forward method, overrides the "),Pt=a(Bo,"CODE",{});var Ji=r(Pt);Yr=i(Ji,"__call__"),Ji.forEach(t),Qr=i(Bo," special method."),Bo.forEach(t),es=p(O),y(Te.$$.fragment,O),os=p(O),se=a(O,"P",{});var Io=r(se);ts=i(Io,"The "),zo=a(Io,"A",{href:!0});var Ui=r(zo);ns=i(Ui,"NllbMoeModel"),Ui.forEach(t),as=i(Io," forward method, overrides the "),St=a(Io,"CODE",{});var Vi=r(St);rs=i(Vi,"__call__"),Vi.forEach(t),ss=i(Io," special method."),Io.forEach(t),is=p(O),y(Me.$$.fragment,O),ls=p(O),y($e.$$.fragment,O),O.forEach(t),Ce.forEach(t),_n=p(o),ie=a(o,"H2",{class:!0});var An=r(ie);Ne=a(An,"A",{id:!0,class:!0,href:!0});var Ki=r(Ne);At=a(Ki,"SPAN",{});var Zi=r(At);y(co.$$.fragment,Zi),Zi.forEach(t),Ki.forEach(t),ds=p(An),jt=a(An,"SPAN",{});var Xi=r(jt);cs=i(Xi,"NllbMoeForConditionalGeneration"),Xi.forEach(t),An.forEach(t),bn=p(o),P=a(o,"DIV",{class:!0});var Le=r(P);y(ho.$$.fragment,Le),hs=p(Le),po=a(Le,"P",{});var jn=r(po);ps=i(jn,`The NllbMoe Model with a language modeling head. Can be used for summarization.
This model inherits from `),qo=a(jn,"A",{href:!0});var Yi=r(qo);us=i(Yi,"PreTrainedModel"),Yi.forEach(t),ms=i(jn,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),jn.forEach(t),fs=p(Le),uo=a(Le,"P",{});var On=r(uo);gs=i(On,"This model is also a PyTorch "),mo=a(On,"A",{href:!0,rel:!0});var Qi=r(mo);_s=i(Qi,"torch.nn.Module"),Qi.forEach(t),bs=i(On,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),On.forEach(t),vs=p(Le),A=a(Le,"DIV",{class:!0});var Fe=r(A);y(fo.$$.fragment,Fe),ys=p(Fe),le=a(Fe,"P",{});var Ro=r(le);ws=i(Ro,"The "),Co=a(Ro,"A",{href:!0});var el=r(Co);ks=i(el,"NllbMoeForConditionalGeneration"),el.forEach(t),Ts=i(Ro," forward method, overrides the "),Ot=a(Ro,"CODE",{});var ol=r(Ot);Ms=i(ol,"__call__"),ol.forEach(t),$s=i(Ro," special method."),Ro.forEach(t),Ns=p(Fe),y(xe.$$.fragment,Fe),xs=p(Fe),y(Ee.$$.fragment,Fe),Fe.forEach(t),Le.forEach(t),this.h()},h(){l(m,"name","hf:doc:metadata"),l(m,"content",JSON.stringify(ml)),l(g,"id","nllbmoe"),l(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(g,"href","#nllbmoe"),l(_,"class","relative group"),l(de,"id","overview"),l(de,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(de,"href","#overview"),l(U,"class","relative group"),l(Se,"href","https://arxiv.org/abs/2207.04672"),l(Se,"rel","nofollow"),l(Ae,"href","https://huggingface.co/ArtZucker"),l(Ae,"rel","nofollow"),l(je,"href","https://github.com/facebookresearch/fairseq"),l(je,"rel","nofollow"),l(he,"id","implementation-differences-with-switchtransformers"),l(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(he,"href","#implementation-differences-with-switchtransformers"),l(V,"class","relative group"),l(pe,"id","generating-with-nllbmoe"),l(pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(pe,"href","#generating-with-nllbmoe"),l(K,"class","relative group"),l(Ge,"href","https://github.com/facebookresearch/flores/blob/main/flores200/README.md#languages-in-flores-200"),l(Ge,"rel","nofollow"),l(ue,"id","generating-from-any-other-language-than-english"),l(ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ue,"href","#generating-from-any-other-language-than-english"),l(Z,"class","relative group"),l(me,"id","documentation-resources"),l(me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(me,"href","#documentation-resources"),l(X,"class","relative group"),l(ko,"href","./tasks/translation"),l(To,"href","./tasks/summarization"),l(ge,"id","transformers.NllbMoeConfig"),l(ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ge,"href","#transformers.NllbMoeConfig"),l(Y,"class","relative group"),l(Mo,"href","/docs/transformers/main/en/model_doc/nllb-moe#transformers.NllbMoeModel"),l(Ue,"href","https://huggingface.co/facebook/nllb-moe-54b"),l(Ue,"rel","nofollow"),l($o,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(No,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(be,"id","transformers.NllbMoeTop2Router"),l(be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(be,"href","#transformers.NllbMoeTop2Router"),l(oe,"class","relative group"),l(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(we,"id","transformers.NllbMoeSparseMLP"),l(we,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(we,"href","#transformers.NllbMoeSparseMLP"),l(ne,"class","relative group"),l(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ke,"id","transformers.NllbMoeModel"),l(ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ke,"href","#transformers.NllbMoeModel"),l(ae,"class","relative group"),l(xo,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),l(io,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(io,"rel","nofollow"),l(Eo,"href","/docs/transformers/main/en/model_doc/nllb-moe#transformers.NllbMoeModel"),l(zo,"href","/docs/transformers/main/en/model_doc/nllb-moe#transformers.NllbMoeModel"),l(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ne,"id","transformers.NllbMoeForConditionalGeneration"),l(Ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Ne,"href","#transformers.NllbMoeForConditionalGeneration"),l(ie,"class","relative group"),l(qo,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),l(mo,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(mo,"rel","nofollow"),l(Co,"href","/docs/transformers/main/en/model_doc/nllb-moe#transformers.NllbMoeForConditionalGeneration"),l(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,d){e(document.head,m),u(o,$,d),u(o,_,d),e(_,g),e(g,b),w(c,b,null),e(_,f),e(_,q),e(q,Dn),u(o,Ht,d),u(o,U,d),e(U,de),e(de,Ho),w(Pe,Ho,null),e(U,Gn),e(U,Wo),e(Wo,Bn),u(o,Wt,d),u(o,ce,d),e(ce,In),e(ce,Se),e(Se,Rn),e(ce,Hn),u(o,Jt,d),u(o,bo,d),e(bo,Wn),u(o,Ut,d),u(o,vo,d),e(vo,Jo),e(Jo,Jn),u(o,Vt,d),u(o,yo,d),e(yo,Un),u(o,Kt,d),u(o,B,d),e(B,Uo),e(Uo,Vn),e(B,Kn),e(B,Vo),e(Vo,Zn),e(B,Xn),e(B,Ko),e(Ko,Yn),u(o,Zt,d),u(o,I,d),e(I,Qn),e(I,Ae),e(Ae,ea),e(I,oa),e(I,je),e(je,ta),e(I,na),u(o,Xt,d),u(o,V,d),e(V,he),e(he,Zo),w(Oe,Zo,null),e(V,aa),e(V,Xo),e(Xo,ra),u(o,Yt,d),u(o,K,d),e(K,pe),e(pe,Yo),w(De,Yo,null),e(K,sa),e(K,Qo),e(Qo,ia),u(o,Qt,d),u(o,R,d),e(R,la),e(R,et),e(et,da),e(R,ca),e(R,ot),e(ot,ha),e(R,pa),u(o,en,d),u(o,H,d),e(H,ua),e(H,tt),e(tt,ma),e(H,fa),e(H,Ge),e(Ge,ga),e(H,_a),u(o,on,d),w(Be,o,d),u(o,tn,d),u(o,Z,d),e(Z,ue),e(ue,nt),w(Ie,nt,null),e(Z,ba),e(Z,at),e(at,va),u(o,nn,d),u(o,W,d),e(W,ya),e(W,rt),e(rt,wa),e(W,ka),e(W,st),e(st,Ta),e(W,Ma),u(o,an,d),u(o,wo,d),e(wo,$a),u(o,rn,d),w(Re,o,d),u(o,sn,d),u(o,X,d),e(X,me),e(me,it),w(He,it,null),e(X,Na),e(X,lt),e(lt,xa),u(o,ln,d),u(o,fe,d),e(fe,dt),e(dt,ko),e(ko,Ea),e(fe,za),e(fe,ct),e(ct,To),e(To,qa),u(o,dn,d),u(o,Y,d),e(Y,ge),e(ge,ht),w(We,ht,null),e(Y,Ca),e(Y,pt),e(pt,La),u(o,cn,d),u(o,L,d),w(Je,L,null),e(L,Fa),e(L,Q),e(Q,Pa),e(Q,Mo),e(Mo,Sa),e(Q,Aa),e(Q,Ue),e(Ue,ja),e(Q,Oa),e(L,Da),e(L,ee),e(ee,Ga),e(ee,$o),e($o,Ba),e(ee,Ia),e(ee,No),e(No,Ra),e(ee,Ha),e(L,Wa),w(_e,L,null),u(o,hn,d),u(o,oe,d),e(oe,be),e(be,ut),w(Ve,ut,null),e(oe,Ja),e(oe,mt),e(mt,Ua),u(o,pn,d),u(o,N,d),w(Ke,N,null),e(N,Va),e(N,ft),e(ft,Ka),e(N,Za),e(N,Ze),e(Ze,Xa),e(Ze,gt),e(gt,Ya),e(Ze,Qa),e(N,er),e(N,_t),e(_t,or),e(N,tr),e(N,ve),w(Xe,ve,null),e(ve,nr),e(ve,te),e(te,ar),e(te,bt),e(bt,rr),e(te,sr),e(te,vt),e(vt,ir),e(te,lr),e(N,dr),e(N,ye),w(Ye,ye,null),e(ye,cr),e(ye,yt),e(yt,hr),u(o,un,d),u(o,ne,d),e(ne,we),e(we,wt),w(Qe,wt,null),e(ne,pr),e(ne,kt),e(kt,ur),u(o,mn,d),u(o,D,d),w(eo,D,null),e(D,mr),e(D,Tt),e(Tt,fr),e(D,gr),e(D,S),w(oo,S,null),e(S,_r),e(S,to),e(to,br),e(to,Mt),e(Mt,vr),e(to,yr),e(S,wr),e(S,x),e(x,kr),e(x,$t),e($t,Tr),e(x,Mr),e(x,Nt),e(Nt,$r),e(x,Nr),e(x,xt),e(xt,xr),e(x,Er),e(x,Et),e(Et,zr),e(x,qr),e(x,zt),e(zt,Cr),e(x,Lr),e(x,qt),e(qt,Fr),e(x,Pr),e(S,Sr),e(S,Ct),e(Ct,Ar),u(o,fn,d),u(o,ae,d),e(ae,ke),e(ke,Lt),w(no,Lt,null),e(ae,jr),e(ae,Ft),e(Ft,Or),u(o,gn,d),u(o,F,d),w(ao,F,null),e(F,Dr),e(F,ro),e(ro,Gr),e(ro,xo),e(xo,Br),e(ro,Ir),e(F,Rr),e(F,so),e(so,Hr),e(so,io),e(io,Wr),e(so,Jr),e(F,Ur),e(F,E),w(lo,E,null),e(E,Vr),e(E,re),e(re,Kr),e(re,Eo),e(Eo,Zr),e(re,Xr),e(re,Pt),e(Pt,Yr),e(re,Qr),e(E,es),w(Te,E,null),e(E,os),e(E,se),e(se,ts),e(se,zo),e(zo,ns),e(se,as),e(se,St),e(St,rs),e(se,ss),e(E,is),w(Me,E,null),e(E,ls),w($e,E,null),u(o,_n,d),u(o,ie,d),e(ie,Ne),e(Ne,At),w(co,At,null),e(ie,ds),e(ie,jt),e(jt,cs),u(o,bn,d),u(o,P,d),w(ho,P,null),e(P,hs),e(P,po),e(po,ps),e(po,qo),e(qo,us),e(po,ms),e(P,fs),e(P,uo),e(uo,gs),e(uo,mo),e(mo,_s),e(uo,bs),e(P,vs),e(P,A),w(fo,A,null),e(A,ys),e(A,le),e(le,ws),e(le,Co),e(Co,ks),e(le,Ts),e(le,Ot),e(Ot,Ms),e(le,$s),e(A,Ns),w(xe,A,null),e(A,xs),w(Ee,A,null),vn=!0},p(o,[d]){const go={};d&2&&(go.$$scope={dirty:d,ctx:o}),_e.$set(go);const Dt={};d&2&&(Dt.$$scope={dirty:d,ctx:o}),Te.$set(Dt);const Gt={};d&2&&(Gt.$$scope={dirty:d,ctx:o}),Me.$set(Gt);const Bt={};d&2&&(Bt.$$scope={dirty:d,ctx:o}),$e.$set(Bt);const _o={};d&2&&(_o.$$scope={dirty:d,ctx:o}),xe.$set(_o);const It={};d&2&&(It.$$scope={dirty:d,ctx:o}),Ee.$set(It)},i(o){vn||(k(c.$$.fragment,o),k(Pe.$$.fragment,o),k(Oe.$$.fragment,o),k(De.$$.fragment,o),k(Be.$$.fragment,o),k(Ie.$$.fragment,o),k(Re.$$.fragment,o),k(He.$$.fragment,o),k(We.$$.fragment,o),k(Je.$$.fragment,o),k(_e.$$.fragment,o),k(Ve.$$.fragment,o),k(Ke.$$.fragment,o),k(Xe.$$.fragment,o),k(Ye.$$.fragment,o),k(Qe.$$.fragment,o),k(eo.$$.fragment,o),k(oo.$$.fragment,o),k(no.$$.fragment,o),k(ao.$$.fragment,o),k(lo.$$.fragment,o),k(Te.$$.fragment,o),k(Me.$$.fragment,o),k($e.$$.fragment,o),k(co.$$.fragment,o),k(ho.$$.fragment,o),k(fo.$$.fragment,o),k(xe.$$.fragment,o),k(Ee.$$.fragment,o),vn=!0)},o(o){T(c.$$.fragment,o),T(Pe.$$.fragment,o),T(Oe.$$.fragment,o),T(De.$$.fragment,o),T(Be.$$.fragment,o),T(Ie.$$.fragment,o),T(Re.$$.fragment,o),T(He.$$.fragment,o),T(We.$$.fragment,o),T(Je.$$.fragment,o),T(_e.$$.fragment,o),T(Ve.$$.fragment,o),T(Ke.$$.fragment,o),T(Xe.$$.fragment,o),T(Ye.$$.fragment,o),T(Qe.$$.fragment,o),T(eo.$$.fragment,o),T(oo.$$.fragment,o),T(no.$$.fragment,o),T(ao.$$.fragment,o),T(lo.$$.fragment,o),T(Te.$$.fragment,o),T(Me.$$.fragment,o),T($e.$$.fragment,o),T(co.$$.fragment,o),T(ho.$$.fragment,o),T(fo.$$.fragment,o),T(xe.$$.fragment,o),T(Ee.$$.fragment,o),vn=!1},d(o){t(m),o&&t($),o&&t(_),M(c),o&&t(Ht),o&&t(U),M(Pe),o&&t(Wt),o&&t(ce),o&&t(Jt),o&&t(bo),o&&t(Ut),o&&t(vo),o&&t(Vt),o&&t(yo),o&&t(Kt),o&&t(B),o&&t(Zt),o&&t(I),o&&t(Xt),o&&t(V),M(Oe),o&&t(Yt),o&&t(K),M(De),o&&t(Qt),o&&t(R),o&&t(en),o&&t(H),o&&t(on),M(Be,o),o&&t(tn),o&&t(Z),M(Ie),o&&t(nn),o&&t(W),o&&t(an),o&&t(wo),o&&t(rn),M(Re,o),o&&t(sn),o&&t(X),M(He),o&&t(ln),o&&t(fe),o&&t(dn),o&&t(Y),M(We),o&&t(cn),o&&t(L),M(Je),M(_e),o&&t(hn),o&&t(oe),M(Ve),o&&t(pn),o&&t(N),M(Ke),M(Xe),M(Ye),o&&t(un),o&&t(ne),M(Qe),o&&t(mn),o&&t(D),M(eo),M(oo),o&&t(fn),o&&t(ae),M(no),o&&t(gn),o&&t(F),M(ao),M(lo),M(Te),M(Me),M($e),o&&t(_n),o&&t(ie),M(co),o&&t(bn),o&&t(P),M(ho),M(fo),M(xe),M(Ee)}}}const ml={local:"nllbmoe",sections:[{local:"overview",title:"Overview"},{local:"implementation-differences-with-switchtransformers",title:"Implementation differences with SwitchTransformers"},{local:"generating-with-nllbmoe",sections:[{local:"generating-from-any-other-language-than-english",title:"Generating from any other language than English"}],title:"Generating with NLLB-MoE"},{local:"documentation-resources",title:"Documentation resources"},{local:"transformers.NllbMoeConfig",title:"NllbMoeConfig"},{local:"transformers.NllbMoeTop2Router",title:"NllbMoeTop2Router"},{local:"transformers.NllbMoeSparseMLP",title:"NllbMoeSparseMLP"},{local:"transformers.NllbMoeModel",title:"NllbMoeModel"},{local:"transformers.NllbMoeForConditionalGeneration",title:"NllbMoeForConditionalGeneration"}],title:"NLLB-MOE"};function fl(z){return sl(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class kl extends tl{constructor(m){super();nl(this,m,fl,ul,al,{})}}export{kl as default,ml as metadata};
